package cn.iigrowing.study.json.demo2;
import java.util.HashMap;
import java.util.Map;

import org.json.JSONObject;


public class JSONObjectTest {
    
    public static void main(String[] args) {
        jSONObject();
        creatJsonByMap();
        creatJsonByBean();
    }

    /**
     * @Description：使用JSONObject来构建JSON对象
     */
    private static void jSONObject() {
        // 创建一个JSONObject对象
        JSONObject zhangsan = new JSONObject();
        Object nullObj = null;
        
        zhangsan.put("name", "张三");
        zhangsan.put("age", 25);
        zhangsan.put("birthday", "1994-12-12");
        zhangsan.put("school", "西安电子科技大学");
        zhangsan.put("major", new String[] {"Java", "C++"});
        zhangsan.put("has_house", false);
        zhangsan.put("house", nullObj);
        JSONObject car = new JSONObject();
        car.put("sign", "奔驰");
        car.put("model", "SUV");
        zhangsan.put("car", car);
        zhangsan.put("comment", "标准JSON里面没有注释");
        
        // print
        System.out.println(zhangsan.toString());
        // {"car":{"sign":"奔驰","model":"SUV"},"birthday":"1994-12-12","school":"西安电子科技大学","age":25,"name":"张三","has_house":false,"comment":"标准JSON里面没有注释","major":["Java","C++"]}
//        {
//        	"car": {
//        		"sign": "奔驰",
//        		"model": "SUV"
//        	},
//        	"birthday": "1994-12-12",
//        	"school": "西安电子科技大学",
//        	"age": 25,
//        	"name": "张三",
//        	"has_house": false,
//        	"comment": "标准JSON里面没有注释",
//        	"major": ["Java", "C++"]
//        }
    }
    
    /**
     * @Description：使用Map来构建JSON对象
     */
    private static void creatJsonByMap() {
        Map<String, Object> zhangsan = new HashMap<String, Object>();
        
        zhangsan.put("name", "张三");
        zhangsan.put("age", 25);
        zhangsan.put("birthday", "1994-12-12");
        zhangsan.put("school", "西安电子科技大学");
        zhangsan.put("major", new String[] {"Java", "C++"});
        zhangsan.put("has_house", false);
        zhangsan.put("house", null);
        Map<String, Object> car = new HashMap<String, Object>();
        car.put("sign", "奔驰");
        car.put("model", "SUV");
        zhangsan.put("car", car);
        zhangsan.put("comment", "标准JSON里面没有注释");
        
        // JSONObject支持使用Map对象直接构造JSON对象
        System.out.println(new JSONObject(zhangsan));
    }
    
    /**
     * @Description：使用Java Bean对象来构建JSON对象 （推荐使用的方式）
     */
    private static void creatJsonByBean() {
        Person zhangsan = new Person();
        zhangsan.setName("张三");
        zhangsan.setAge(25);
        zhangsan.setBirthday("1994-12-12");
        zhangsan.setSchool("西安电子科技大学");
        zhangsan.setMajor(new String[] {"Java", "C++"});
        zhangsan.setHas_house(false);
        zhangsan.setHouse(null);
        zhangsan.setCar(new Car("奔驰", "SUV"));
        zhangsan.setComment("标准JSON里面没有注释");
        
        // JSONObject支持使用Java Bean对象直接构造JSON对象
        System.out.println(new JSONObject(zhangsan));
    }
}